<?php
/*---------------------------------------------------------------*/
/*
    Titre : WHOIS PHP                                                                                                     
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=1078
    Auteur           : sheppy1                                                                                            
    Date dition     : 25 Juil 2019                                                                                       
    Date mise  jour : 13 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
*/
/*---------------------------------------------------------------*/
     function whois_query($domain) {
      
        // fix the domain name:
        $domain = strtolower(trim($domain));
        $domain = preg_replace('/^http:\/\//i', '', $domain);
        $domain = preg_replace('/^www\./i', '', $domain);
        $domain = explode('/', $domain);
        $domain = trim($domain[0]);
      
        // split the TLD from domain name
        $_domain = explode('.', $domain);
        $lst = count($_domain)-1;
        $ext = $_domain[$lst];
     
        $servers = array(
     
            // "net" => "whois.internic.net",
            // "com" => "whois.internic.net",
            "fr" => "whois.nic.fr"
     
        );
      
        if (!isset($servers[$ext])){
            die('Erreur: Aucun serveur nic correspondant de trouver!');
        }
      
        $nic_server = $servers[$ext];
      
        $output = '';
      
        // connect to whois server:
        if ($conn = fsockopen ($nic_server, 43)) {
            fputs($conn, $domain."\r\n");
            while(!feof($conn)) {
                $output .= fgets($conn,128);
            }
            fclose($conn);
        }
     else { die('Erreur: Impossible de se connecter a ' . $nic_server . '!'); }
      
        return $output;
    }
?>